#!/usr/bin/perl -w
use strict;

my $sim_pileup= $ARGV[0]; #sim_F1_hetero_pileup
my $bam_file= $ARGV[1]; #A_bulk_bam
my $bam_file_p=$ARGV[2]; #P1_bam
my $reference_fasta = $ARGV[3];
my $samtools_dir=$ARGV[4];
my $depht=$ARGV[5];

open (FILE1, $sim_pileup) or die "cannot open file";
open (FILE2, "$samtools_dir mpileup -f $reference_fasta $bam_file $bam_file_p |") or die "cannot open file";



my $bam_file_name=$bam_file;
$bam_file_name=~s/\S+\///;
$bam_file_name=~s/_all_mapped_sort.bam//;
my $out_put_file="m_common_F1_hetero_snp_P1_vs_A_bulk.pileup";
open OUTPUT, ">$out_put_file\n" or die "cannot open file";

my %hash=();
while (my $file = <FILE1>){
    chomp $file;
    my @colom=split(/\t/,$file);
    
    my $chr=$colom[0];
    my $posi=$colom[1];
    my $p_depth=[4];
    
    my $chr_posi="${chr}:${posi}";
    # print "$chr_posi\n";
    $hash{$chr_posi}=1;

}




while (my $file = <FILE2>) {
    chomp $file;
    my @colom = split (/\t/, $file);

	my $chr=$colom[0];
    my $posi=$colom[1];
    my $bulk_depth=$colom[3];
    my $nucleotide_collum=$colom[4];
    my $p_depth=$colom[6];
    my $chr_posi="${chr}:${posi}";
    if (exists($hash{$chr_posi})){
        if($bulk_depth>=$depht and $bulk_depth<=300){
            if($nucleotide_collum=~/\+\d+/ig or $nucleotide_collum=~/\-\d+/ig){
            }else{
            	$nucleotide_collum=~s/\W//ig;
                # print "$nucleotide_collum\n";
                my $SNP_num=length($nucleotide_collum);
                # print "$SNP_num\n";
                my $SNP_index=$SNP_num/$bulk_depth;
	    		
        		print OUTPUT "$chr\t$posi\t$p_depth\t$bulk_depth\t$SNP_index\n";

    		
            }
        }
    }
    
}

close OUTPUT;
